package com.huimv.admin.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.DataUill;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.EnvWarning;
import com.huimv.admin.entity.vo.WarningTopVo;
import com.huimv.admin.mapper.EnvWarningMapper;
import com.huimv.admin.service.IEnvWarningService;
import io.swagger.models.auth.In;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author author
 * @since 2023-03-23
 */
@RestController
@RequestMapping("/env-warning")
@CrossOrigin
public class EnvWarningController {
    @Autowired
    private IEnvWarningService envWarningService;
    @Autowired
    private EnvWarningMapper envWarningMapper;

    @PostMapping("/listCount")
    public Result listWarningCount(@RequestBody Map<String,String> paramsMap){
        return envWarningService.listCount(paramsMap);
    }

    @PostMapping("/list")
    public Result listWarning(@RequestBody Map<String ,String> paramsMap){
        return envWarningService.listWarning(paramsMap);
    }

    @PostMapping("/listTop")
    public Result listTop(@RequestBody Map<String ,String> paramsMap){
        return envWarningService.listTop(paramsMap);
    }

    @PostMapping("/appList")
    public Result listAppWarning(@RequestBody Map<String ,String> paramsMap ){
        String farmId = paramsMap.get("farmId");
        Date timesMonthmorning = DataUill.getTimesMonthmorning();
        Date timesmorning = DataUill.getTimesmorning();
        List<WarningTopVo> warningTopVos = envWarningMapper.listTop(farmId);
        WarningTopVo warningTopVo = warningTopVos.get(0);
        Integer monthWarning = envWarningService.count(new QueryWrapper<EnvWarning>()
                .ge("update_time", timesMonthmorning)
                .eq("farm_id", farmId));
        Integer dayWarning = envWarningService.count(new QueryWrapper<EnvWarning>()
                .ge("update_time", timesmorning)
                .eq("farm_id", farmId));
        Map resultMap = new HashMap();
        resultMap.put("mostWarning",warningTopVo.getLocation());
        resultMap.put("monthWarning",monthWarning);
        resultMap.put("dayWarning",dayWarning);
        return new Result(ResultCode.SUCCESS,resultMap);
    }
}
